#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "ci067.h"
#include "agenda.h"

ENDERECO leItem ()
{

  ENDERECO item;
  char *mem;

  /* Desnecessario. Apenas mostra um "chuncho" que pode ser usado para
   * "zerar" posicoes de memoria.
   * O leitor deve verificar a razao do uso do cast abaixo.
   */
  mem = (char *) &item;
  while(mem < (char *) &item + sizeof(ENDERECO))
    *mem++ = '\0';
  
  /* Obtem os dados de um item da agenda */
  printf("NOME: ");
  cigets(item.nome, TAM_NOME, stdin);

  if (strlen(item.nome)) {
    printf("ENDERECO: ");
    cigets(item.end, TAM_END, stdin);
    
    printf("FONE: ");
    cigets(item.fone, TAM_FONE, stdin);
    
    printf("E-MAIL: ");
    cigets(item.email, TAM_EMAIL, stdin);
    
    printf("CIDADE: ");
    cigets(item.cidade, TAM_CIDADE, stdin);
    
    printf("ESTADO: ");
    cigets(item.estado, TAM_ESTADO, stdin);
    
    printf("CEP: ");
    cigets(item.cep, TAM_CEP, stdin);

    printf("\n\n%%%%%%%%%%%%%%%%%%%%%%\n\n");
  }

  return item;
}


void imprimeItem (ENDERECO *item)
{
    printf("NOME: %s\n", item->nome);
    printf("ENDERECO: %s\n", item->end);
    printf("FONE: %s\n", item->fone);
    printf("E-MAIL: %s\n", item->email);
    printf("CIDADE: %s\n", item->cidade);
    printf("ESTADO: %s\n", item->estado);
    printf("CEP: %s\n", item->cep);
    printf("-----------------------\n");
}


void imprimeAgenda(ENDERECO *agenda)
{
  
  printf("\n\n=====================\n\n");

  while (strlen(agenda->nome))
    imprimeItem(agenda++);

  printf("\n\n");
}


/* Grava agenda em arquivo */
int gravaAgenda (ENDERECO *agenda, int nelem, FILE *fp)
{
  int status = 1;

  if (fwrite(agenda, sizeof(ENDERECO), nelem, fp) != nelem)
    status = 0;

  return status;
}

/* Le itens da agenda em arquivo */
ENDERECO *leAgenda (int nelem, FILE *fp)
{
  ENDERECO *agenda;

  agenda = (ENDERECO *) calloc (nelem, sizeof(ENDERECO));
  
  if (agenda != NULL)
    fread(agenda, sizeof(ENDERECO), nelem, fp);

  return agenda;
}


main (int argc, char *argv[])
{

  ENDERECO *agenda, *ragenda;
  char arquivo[TAM_ARQNOME];
  int nitens;
  FILE *fp;
 
  if (argc < 2)
    do {
      printf("Entre o nome do arquivo da agenda: ");
    } while (cigets(arquivo, sizeof(arquivo), stdin) == NULL || ! strlen(arquivo));
  else if (argc == 2)
    strcpy (arquivo, argv[1]);

  if (argc > 2)
    printf("\nForma de uso: %s [arquivo_agenda]\n\n", argv[0]);
  else {
    fp = fopen (arquivo, "w+");
    
    if (fp == NULL)
      printf("Erro ao abrir arquivo %s\n", arquivo);
    else {
      agenda = (ENDERECO *) calloc (0, sizeof(ENDERECO));
      
      nitens = 0;
      do {
	agenda = (ENDERECO *) realloc (agenda,
				       (nitens + 1) * sizeof(ENDERECO));
	if (agenda)
	  agenda[nitens] = leItem();
      } while (agenda && strlen(agenda[nitens++].nome));
      
      /*
	 imprimeAgenda(agenda);
       */

      printf("\n\nGravando agenda no arquivo \"%s\" .... ", arquivo);
      if (!gravaAgenda(agenda, nitens - 1, fp))
	printf("Erro na gravacao da agenda !!!!!\n\n");
      else {
	printf("OK!!!!\n\n");
	
	/* Testando gravacao */
	fflush(fp);
	fclose(fp);
	fp = fopen (arquivo, "r");
	
	printf("\n\nLendo agenda do arquivo \"%s\" ....\n\n ", arquivo);
	if ((ragenda = leAgenda(nitens - 1, fp)) != NULL)
	  imprimeAgenda(ragenda);
      }

      fclose(fp);     /* fecha arquivo */
    }  /* FIM (fp == NULL) */
  }  /* FIM (argc > 2) */
}
